#pragma once
#include "RawEvent.hpp"


#ifdef __INPUT_RAWUIEVENT_CPP_ 
#define RAW_UI_EVENT_DECL FDX_DLL_EXPORT 
#else 
#define RAW_UI_EVENT_DECL FDX_DLL_IMPORT 
#endif


namespace Input
{
   class RawUIEvent :
      public RawEvent
   {
   public:
      RAW_UI_EVENT_DECL RawUIEvent();
      RAW_UI_EVENT_DECL RawUIEvent(const parameter_strings & parms);

      /**
      <summary>
      Making the destructor virtual insures that deletions will be handled appropriately. 
      The downside is that the vtable pointer doesn't mean anything if instances are put on
      the bus.
      </summary>
      */
      RAW_UI_EVENT_DECL virtual ~RawUIEvent();

      DECL_CLASS_COMMON_TYPES(RawUIEvent);

      RAW_UI_EVENT_DECL void initialize(const parameter_strings & parms); 

      ///<summary>Give comparisons value semantics</summary>
      RAW_UI_EVENT_DECL bool operator==(RawUIEvent const& cmp) const;

   public:

      /**
      <summary> (from W3C DOM L3 Events) 
      Specifies some detail information about the Event, depending on the type of event.

      The uninitialized value of this attribute must be 0.
      </summary>
      */
      long detail;
   protected:
      friend class boost::serialization::access;
      template<class Archive>
      RAW_UI_EVENT_DECL void serialize(Archive &ar, const unsigned int version);
      //{
      //   ar & boost::serialization::base_object<RawEvent>(*this);
      //   ar & detail;
      //}
         

   
   };

}
BOOST_CLASS_EXPORT_KEY(Input::RawUIEvent);
